<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: emini/eminisolve.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_087401d2fcfe0d344c8cee8acbcc7f48.html">emini</a>
  </div>
</div>
<div class="contents">
<h1>eminisolve.c</h1><a href="eminisolve_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: eminisolve.c 3012 2010-03-26 16:05:11Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="emini_8h.html">emini.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="field_8h.html">field/field.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util/util.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="llg_8h.html">llg/llg.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">io/magpario.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span><span class="preprocessor">#include &quot;addons/addons.h&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#endif</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="preprocessor">#undef DEBUG</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span><span class="keyword">static</span> Vec dMdt=PETSC_NULL;
<a name="l00040"></a>00040 <span class="preprocessor">#endif</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 <span class="comment">/* undef DAMP to use conventional gradient</span>
<a name="l00043"></a>00043 <span class="comment">   define DAMP to use damping term for gradient/line search</span>
<a name="l00044"></a>00044 <span class="comment">*/</span>
<a name="l00045"></a>00045 <span class="preprocessor">#undef DAMP</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span>
<a name="l00047"></a>00047 <span class="comment">/* TODO: problems with using Cartesian coordinates in micromagnetic model:</span>
<a name="l00048"></a>00048 <span class="comment">   |M|==1 is not preserved! M &quot;runs away&quot;! - need penalty term or such</span>
<a name="l00049"></a>00049 <span class="comment">   works great with nonlinear model</span>
<a name="l00050"></a>00050 <span class="comment">*/</span>
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="keyword">static</span> TAO_SOLVER tao;
<a name="l00053"></a>00053 <span class="keyword">static</span> TAO_APPLICATION taoapp;
<a name="l00054"></a>00054 <span class="keyword">static</span> PetscRandom rctx=PETSC_NULL;
<a name="l00055"></a>00055 <span class="keyword">static</span> PetscReal magdist;
<a name="l00056"></a>00056 <span class="keyword">static</span> PetscReal tol;
<a name="l00057"></a>00057 <span class="keyword">static</span> <span class="keywordtype">int</span> tao_max_its;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="keyword">static</span> Vec Msphere;
<a name="l00060"></a>00060 <span class="keyword">static</span> Vec VHtotsphere;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="preprocessor">#if 0</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span><span class="preprocessor">#define NO_VMS3</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="keyword">static</span> Vec X2;
<a name="l00065"></a>00065 <span class="preprocessor">#endif</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>
<a name="l00067"></a>00067 <span class="preprocessor">#undef TESTTORQ</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span><span class="preprocessor">#ifdef TESTTORQ</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span><span class="keyword">static</span> Vec dMdt=PETSC_NULL;
<a name="l00070"></a>00070 <span class="preprocessor">#endif</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00072"></a>00072 <span class="preprocessor">#ifdef DAMP</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span><span class="keyword">static</span> Vec grad;
<a name="l00074"></a>00074 <span class="preprocessor">#endif</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>
<a name="l00076"></a><a class="code" href="eminisolve_8c.html#afdcb9097ab9ba289da2189a2ce6b9385">00076</a> <span class="keywordtype">int</span> <a class="code" href="eminisolve_8c.html#afdcb9097ab9ba289da2189a2ce6b9385">TaoEvalEnergyGrad</a>(TAO_APPLICATION taoapp,Vec X,<span class="keywordtype">double</span> *f, Vec G,<span class="keywordtype">void</span> *ptr)
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078   <a class="code" href="structGridData.html">GridData</a> *gdata = (<a class="code" href="structGridData.html">GridData</a>*)ptr;
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>==53) {
<a name="l00083"></a>00083     <span class="comment">/* FIXME: try to avoid copying vectors here</span>
<a name="l00084"></a>00084 <span class="comment">       can we do gdata-&gt;M=X instead?</span>
<a name="l00085"></a>00085 <span class="comment">       same for gdata-&gt;VHtot=G ?</span>
<a name="l00086"></a>00086 <span class="comment">       search for all VecCopy and try to do something smarter</span>
<a name="l00087"></a>00087 <span class="comment">    */</span>
<a name="l00088"></a>00088     ierr = VecCopy(X,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00089"></a>00089   }
<a name="l00090"></a>00090   <span class="keywordflow">else</span> {
<a name="l00091"></a>00091 <span class="preprocessor">#ifdef NO_VMS3</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>    ierr = VecCopy(X,X2);CHKERRQ(ierr);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094     PetscReal *ta_X, *ta_VMs3;
<a name="l00095"></a>00095     ierr = VecGetArray(X2,&amp;ta_X);CHKERRQ(ierr);
<a name="l00096"></a>00096     ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,&amp;ta_VMs3);CHKERRQ(ierr);
<a name="l00097"></a>00097     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++) {
<a name="l00098"></a>00098       ta_X[2*i+0] /= ta_VMs3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i];
<a name="l00099"></a>00099       ta_X[2*i+1] /= ta_VMs3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i];
<a name="l00100"></a>00100     }
<a name="l00101"></a>00101     ierr = VecRestoreArray(X2,&amp;ta_X);CHKERRQ(ierr);
<a name="l00102"></a>00102     ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,&amp;ta_VMs3);CHKERRQ(ierr);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104     ierr = <a class="code" href="cart2sphere_8c.html#a2f8d6af80c328b771a233e4912be1835">Sphere2Cart</a>(X2,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00105"></a>00105 <span class="preprocessor">#else</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>    ierr = <a class="code" href="cart2sphere_8c.html#a2f8d6af80c328b771a233e4912be1835">Sphere2Cart</a>(X,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00107"></a>00107 <span class="preprocessor">#endif</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>  }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   ierr = <a class="code" href="field_8h.html#a270a74fb6c65379e026cfb5c4de11443">Htot_Gradient</a>(gdata);CHKERRQ(ierr);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="preprocessor">#ifdef DAMP</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>  <span class="comment">/* use damping term instead of field for gradient/line search */</span>
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   PetscReal *ta_M, *ta_Htot, *ta_grad;
<a name="l00116"></a>00116   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);CHKERRQ(ierr);
<a name="l00117"></a>00117   ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,&amp;ta_Htot);CHKERRQ(ierr);
<a name="l00118"></a>00118   ierr = VecGetArray(grad,&amp;ta_grad);CHKERRQ(ierr);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++) {
<a name="l00121"></a>00121     PetscReal  *damp, mxh[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00122"></a>00122     PetscReal  a1;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124     <span class="comment">/* skip non-magnetic vertices */</span>
<a name="l00125"></a>00125     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[i]+4]&lt;=0.0) <span class="keywordflow">continue</span>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127     damp=ta_grad+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129     <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,ta_Htot+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,mxh);
<a name="l00130"></a>00130     <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,mxh,damp);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132     <span class="comment">/* use small parameter to keep residual for TAO small */</span>
<a name="l00133"></a>00133     a1=0.001;
<a name="l00134"></a>00134     <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,a1,damp,1);
<a name="l00135"></a>00135   }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);CHKERRQ(ierr);
<a name="l00138"></a>00138   ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,&amp;ta_Htot);CHKERRQ(ierr);
<a name="l00139"></a>00139   ierr = VecRestoreArray(grad,&amp;ta_grad);CHKERRQ(ierr);
<a name="l00140"></a>00140 <span class="preprocessor">#endif</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>
<a name="l00142"></a>00142   ierr = <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);CHKERRQ(ierr);
<a name="l00143"></a>00143   *f=gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="comment">/* Test gradient with these options:</span>
<a name="l00146"></a>00146 <span class="comment">  -tao_method tao_fd_test</span>
<a name="l00147"></a>00147 <span class="comment">  -tao_test_gradient</span>
<a name="l00148"></a>00148 <span class="comment">  -tao_test_display</span>
<a name="l00149"></a>00149 <span class="comment">*/</span>
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="preprocessor">#ifdef DAMP</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>==53) {
<a name="l00153"></a>00153     ierr = VecCopy(grad,G);CHKERRQ(ierr);
<a name="l00154"></a>00154   }
<a name="l00155"></a>00155   <span class="keywordflow">else</span> {
<a name="l00156"></a>00156     ierr = <a class="code" href="cart2sphere_8c.html#aac1a7d4f53770aebf3759a36a9d384b6">Cart2SphereDiff</a>(grad,X,G);CHKERRQ(ierr);
<a name="l00157"></a>00157   }
<a name="l00158"></a>00158 <span class="preprocessor">#else</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>==53) {
<a name="l00160"></a>00160     ierr = VecCopy(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,G);CHKERRQ(ierr);
<a name="l00161"></a>00161   }
<a name="l00162"></a>00162   <span class="keywordflow">else</span> {
<a name="l00163"></a>00163     ierr = <a class="code" href="cart2sphere_8c.html#aac1a7d4f53770aebf3759a36a9d384b6">Cart2SphereDiff</a>(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,X,G);CHKERRQ(ierr);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="preprocessor">#ifdef NO_VMS3</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>    PetscReal *ta_X, *ta_VMs3;
<a name="l00167"></a>00167     ierr = VecGetArray(G,&amp;ta_X);CHKERRQ(ierr);
<a name="l00168"></a>00168     ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,&amp;ta_VMs3);CHKERRQ(ierr);
<a name="l00169"></a>00169     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++) {
<a name="l00170"></a>00170       ta_X[2*i+0] *= ta_VMs3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i];
<a name="l00171"></a>00171       ta_X[2*i+1] *= ta_VMs3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i];
<a name="l00172"></a>00172     }
<a name="l00173"></a>00173     ierr = VecRestoreArray(G,&amp;ta_X);CHKERRQ(ierr);
<a name="l00174"></a>00174     ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#ac9ae4905283e303be4794e8f222086cb">VMs3</a>,&amp;ta_VMs3);CHKERRQ(ierr);
<a name="l00175"></a>00175 <span class="preprocessor">#endif</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>  }
<a name="l00177"></a>00177 <span class="preprocessor">#endif</span>
<a name="l00178"></a>00178 <span class="preprocessor"></span>
<a name="l00179"></a>00179   <span class="comment">/* DEBUG</span>
<a name="l00180"></a>00180 <span class="comment">  PetscPrintf(PETSC_COMM_WORLD,&quot;deb01 X\n&quot;);</span>
<a name="l00181"></a>00181 <span class="comment">  VecView(X,PETSC_VIEWER_STDOUT_WORLD);</span>
<a name="l00182"></a>00182 <span class="comment">  PetscPrintf(PETSC_COMM_WORLD,&quot;deb01 VHtot\n&quot;);</span>
<a name="l00183"></a>00183 <span class="comment">  VecView(gdata-&gt;VHtot,PETSC_VIEWER_STDOUT_WORLD);</span>
<a name="l00184"></a>00184 <span class="comment">  PetscPrintf(PETSC_COMM_WORLD,&quot;deb01 G\n&quot;);</span>
<a name="l00185"></a>00185 <span class="comment">  VecView(G,PETSC_VIEWER_STDOUT_WORLD);</span>
<a name="l00186"></a>00186 <span class="comment">  */</span>
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00189"></a>00189 }
<a name="l00190"></a>00190 
<a name="l00191"></a><a class="code" href="eminisolve_8c.html#a5eef315eb34f052b9e148bd70caaea92">00191</a> <span class="keywordtype">int</span> <a class="code" href="eminisolve_8c.html#a5eef315eb34f052b9e148bd70caaea92">ConvTest</a>(TAO_SOLVER tao,<span class="keywordtype">void</span> *cctx)
<a name="l00192"></a>00192 {
<a name="l00193"></a>00193   <a class="code" href="structGridData.html">GridData</a> *gdata = (<a class="code" href="structGridData.html">GridData</a>*)cctx;
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="keywordtype">int</span> iter;
<a name="l00198"></a>00198   <span class="keywordtype">double</span> ff,gnorm,cnorm,xdiff;
<a name="l00199"></a>00199   TaoTerminateReason reason;
<a name="l00200"></a>00200   ierr = TaoGetSolutionStatus(tao,&amp;iter,&amp;ff,&amp;gnorm,&amp;cnorm,&amp;xdiff,&amp;reason);CHKERRQ(ierr);
<a name="l00201"></a>00201   <span class="keywordflow">if</span> (iter&gt;tao_max_its) {
<a name="l00202"></a>00202     ierr = TaoSetTerminationReason(tao,TAO_DIVERGED_MAXITS);CHKERRQ(ierr);
<a name="l00203"></a>00203     <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00204"></a>00204   }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="preprocessor">#ifdef TESTTORQ</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>  <span class="comment">/* test based on torque dM/dt - does not work well</span>
<a name="l00208"></a>00208 <span class="comment">     torque&gt;0 in energy minimum!?</span>
<a name="l00209"></a>00209 <span class="comment">     however torque-&gt;0 is not (strict) energy minimum</span>
<a name="l00210"></a>00210 <span class="comment">  */</span>
<a name="l00211"></a>00211   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>!=53) {
<a name="l00212"></a>00212     Vec sol;
<a name="l00213"></a>00213     ierr = TaoAppGetSolutionVec(taoapp,&amp;sol);CHKERRQ(ierr);
<a name="l00214"></a>00214     assert(sol==Msphere);
<a name="l00215"></a>00215     ierr = <a class="code" href="cart2sphere_8c.html#a2f8d6af80c328b771a233e4912be1835">Sphere2Cart</a>(sol,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00216"></a>00216   }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   ierr = <a class="code" href="calc__dMdt_8c.html#aa814b25d7c7a65198ca75426fb6d7403">calc_dMdt</a>(PETSC_NULL,0.0,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,dMdt,gdata);CHKERRQ(ierr);
<a name="l00219"></a>00219   gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a>=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(dMdt,0.0,PETSC_MAX,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   ierr = TaoGetTerminationReason(tao,&amp;reason);CHKERRQ(ierr);
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;torque = %g  Etot = %g %g  reason = %i\n&quot;</span>,
<a name="l00224"></a>00224     gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a>,gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>,gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,reason
<a name="l00225"></a>00225   );
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="keyword">static</span> <span class="keywordtype">int</span> equil=0;
<a name="l00228"></a>00228   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a> &lt;= tol) {
<a name="l00229"></a>00229     ierr = TaoSetTerminationReason(tao,TAO_CONVERGED_USER);CHKERRQ(ierr);
<a name="l00230"></a>00230     <span class="comment">/* count how long we have been in equilibrium in succession */</span>
<a name="l00231"></a>00231     equil++;
<a name="l00232"></a>00232   }
<a name="l00233"></a>00233   <span class="keywordflow">else</span> {
<a name="l00234"></a>00234     ierr = TaoSetTerminationReason(tao,TAO_CONTINUE_ITERATING);CHKERRQ(ierr);
<a name="l00235"></a>00235     <span class="comment">/* reset counter if we are not in equilibrium */</span>
<a name="l00236"></a>00236     equil=0;
<a name="l00237"></a>00237   }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 <span class="preprocessor">#else</span>
<a name="l00240"></a>00240 <span class="preprocessor"></span>  <span class="comment">/* test based on change in energy */</span>
<a name="l00241"></a>00241   <span class="keyword">static</span> PetscReal Etotold;
<a name="l00242"></a>00242   <span class="keyword">static</span> <span class="keywordtype">int</span> equil;
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="keywordflow">if</span> (iter==0) {
<a name="l00245"></a>00245     equil=0;
<a name="l00246"></a>00246     Etotold=PETSC_MAX;
<a name="l00247"></a>00247   }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   PetscLogDouble t_now;
<a name="l00250"></a>00250   PetscGetTime(&amp;t_now);
<a name="l00251"></a>00251   <span class="keyword">static</span> PetscLogDouble t_last=t_now;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%5i %4i %6.2f %22.16e %22.16e %22.16e %22.16e %22.16e&quot;</span>,
<a name="l00254"></a>00254     iter,
<a name="l00255"></a>00255     equil,
<a name="l00256"></a>00256     t_now-t_last,
<a name="l00257"></a>00257     gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>,gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00258"></a>00258     Etotold,Etotold*gdata-&gt;<a class="code" href="structGridData.html#af5ca6e17784da000ea45ebb5f65ebd03">escale</a>,
<a name="l00259"></a>00259     (Etotold-gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>)/PetscAbsReal(gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>)
<a name="l00260"></a>00260   );
<a name="l00261"></a>00261 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00262"></a>00262 <span class="preprocessor"></span>  ierr = <a class="code" href="calc__dMdt_8c.html#aa814b25d7c7a65198ca75426fb6d7403">calc_dMdt</a>(PETSC_NULL,0.0,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,dMdt,gdata);CHKERRQ(ierr);
<a name="l00263"></a>00263   gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a>=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(dMdt,0.0,PETSC_MAX,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;%22.16e&quot;</span>,
<a name="l00266"></a>00266     gdata-&gt;<a class="code" href="structGridData.html#ad44d2e83b58c9fc6b13f7fb3258bc323">vequil</a>
<a name="l00267"></a>00267   );
<a name="l00268"></a>00268 <span class="preprocessor">#endif</span>
<a name="l00269"></a>00269 <span class="preprocessor"></span>  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;\n&quot;</span>);
<a name="l00270"></a>00270   t_last=t_now;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="comment">/* Etotold-gdata-&gt;Etot &lt; 0 when energy increases</span>
<a name="l00273"></a>00273 <span class="comment">     This can happen around energy minimum, due to numerical errors.</span>
<a name="l00274"></a>00274 <span class="comment">     We allow it as long as |delta E|&lt;tol.</span>
<a name="l00275"></a>00275 <span class="comment">  */</span>
<a name="l00276"></a>00276 <span class="preprocessor">#define NEQUIL 5</span>
<a name="l00277"></a>00277 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (PetscAbs(Etotold-gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>)/PetscAbsReal(gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>)&lt;tol) {
<a name="l00278"></a>00278     <span class="keywordflow">if</span> (equil&gt;=<a class="code" href="eminisolve_8c.html#a377e15c3c88d89126b722a1a3d76ec86">NEQUIL</a>) {
<a name="l00279"></a>00279       ierr = TaoSetTerminationReason(tao,TAO_CONVERGED_USER);CHKERRQ(ierr);
<a name="l00280"></a>00280       equil=0;
<a name="l00281"></a>00281     }
<a name="l00282"></a>00282     <span class="keywordflow">else</span> {
<a name="l00283"></a>00283       ierr = TaoSetTerminationReason(tao,TAO_CONTINUE_ITERATING);CHKERRQ(ierr);
<a name="l00284"></a>00284       <span class="comment">/* count how long we have been in equilibrium in succession */</span>
<a name="l00285"></a>00285       equil++;
<a name="l00286"></a>00286     }
<a name="l00287"></a>00287   }
<a name="l00288"></a>00288   <span class="keywordflow">else</span> {
<a name="l00289"></a>00289     ierr = TaoSetTerminationReason(tao,TAO_CONTINUE_ITERATING);CHKERRQ(ierr);
<a name="l00290"></a>00290     <span class="comment">/* reset counter if we are not in equilibrium */</span>
<a name="l00291"></a>00291     equil=0;
<a name="l00292"></a>00292   }
<a name="l00293"></a>00293   Etotold=gdata-&gt;<a class="code" href="structGridData.html#a3a7aa0cd7fb9d423a39262c6c0079e62">Etot</a>;
<a name="l00294"></a>00294 <span class="preprocessor">#endif</span>
<a name="l00295"></a>00295 <span class="preprocessor"></span>
<a name="l00296"></a>00296 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00297"></a>00297 <span class="preprocessor"></span>  ierr = <a class="code" href="magpario_8h.html#ad970cf1663bac1ede525a5caf43750fd">WriteLog</a>(gdata);CHKERRQ(ierr);
<a name="l00298"></a>00298   gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=PetscAbsInt(gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00299"></a>00299   ierr = <a class="code" href="magpario_8h.html#a7ff05d6bfdfc02445d6245fec57f686e">WriteSet</a>(gdata);CHKERRQ(ierr);
<a name="l00300"></a>00300 <span class="preprocessor">#endif</span>
<a name="l00301"></a>00301 <span class="preprocessor"></span>
<a name="l00302"></a>00302   <a class="code" href="griddata_8h.html#a9a4d090c28602d7ff7ec883fb6f413db">MagparFunctionProfReturn</a>(0);
<a name="l00303"></a>00303 }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a><a class="code" href="eminisolve_8c.html#a7be0557728f95ef22f1ba7f2b99b5707">00306</a> <span class="keywordtype">int</span> <a class="code" href="eminisolve_8c.html#a7be0557728f95ef22f1ba7f2b99b5707">myTSCreateEmini</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00307"></a>00307 {
<a name="l00308"></a>00308   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   gdata-&gt;<a class="code" href="structGridData.html#a9eb9246406e97a2a4a8a9c471b11aa2a">time</a> = 0.0;
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 <span class="preprocessor">#ifdef DAMP</span>
<a name="l00313"></a>00313 <span class="preprocessor"></span>  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;DAMP defined: Using damping term for gradient/line search\n&quot;</span>);
<a name="l00314"></a>00314   ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;grad);CHKERRQ(ierr);
<a name="l00315"></a>00315 <span class="preprocessor">#else</span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>  PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;DAMP undefined: Using field for gradient/line search\n&quot;</span>);
<a name="l00317"></a>00317 <span class="preprocessor">#endif</span>
<a name="l00318"></a>00318 <span class="preprocessor"></span>
<a name="l00319"></a>00319   <span class="comment">/* set default for tao_lmm_vectors */</span>
<a name="l00320"></a>00320   PetscTruth flg;
<a name="l00321"></a>00321   <span class="keywordtype">int</span> tao_lmm_vectors;
<a name="l00322"></a>00322   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-tao_lmm_vectors&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;tao_lmm_vectors,&amp;flg);CHKERRQ(ierr);
<a name="l00323"></a>00323   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00324"></a>00324     ierr = PetscOptionsSetValue(<span class="stringliteral">&quot;-tao_lmm_vectors&quot;</span>,<span class="stringliteral">&quot;100&quot;</span>);CHKERRQ(ierr);
<a name="l00325"></a>00325   }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327   <span class="keywordtype">char</span> str[256];
<a name="l00328"></a>00328   PetscOptionsGetString(PETSC_NULL,<span class="stringliteral">&quot;-tao_method&quot;</span>,str,256,&amp;flg);
<a name="l00329"></a>00329   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00330"></a>00330     ierr = PetscSNPrintf(str,255,<span class="stringliteral">&quot;tao_lmvm&quot;</span>);CHKERRQ(ierr);
<a name="l00331"></a>00331     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00332"></a>00332       <span class="stringliteral">&quot;Option -tao_method not found, using default value: %s\n&quot;</span>,
<a name="l00333"></a>00333       str
<a name="l00334"></a>00334     );
<a name="l00335"></a>00335   }
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   ierr = TaoCreate(PETSC_COMM_WORLD,str,&amp;tao);CHKERRQ(ierr);
<a name="l00338"></a>00338   ierr = TaoApplicationCreate(PETSC_COMM_WORLD,&amp;taoapp);CHKERRQ(ierr);
<a name="l00339"></a>00339   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>==53) {
<a name="l00340"></a>00340     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;mode %i: Using 3D Cartesian coordinates\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342     PetscReal *ta_M;
<a name="l00343"></a>00343     ierr = VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);CHKERRQ(ierr);
<a name="l00344"></a>00344     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0;j&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>;j++) {
<a name="l00345"></a>00345       PetscReal ms;
<a name="l00346"></a>00346       ms=gdata-&gt;<a class="code" href="structGridData.html#a3df9afbdf3e91a79a68b52cae80020f4">propdat</a>[<a class="code" href="griddata_8h.html#ab04c88bedc6b2be8ddfe7aa8d3e93f06">NP</a>*gdata-&gt;<a class="code" href="structGridData.html#a5b4aaaf0ac71daeb341f45b50b6c744e">vertprop</a>[j]+4];
<a name="l00347"></a>00347       <span class="comment">/* if the magnetic moment of the material is 0 */</span>
<a name="l00348"></a>00348       <span class="keywordflow">if</span> (ms==0.0) {
<a name="l00349"></a>00349         <span class="comment">/* set magnetization to 0 */</span>
<a name="l00350"></a>00350         <span class="comment">/* This is necessary, because we set Hnonlin=0 for Ms=0 or mu=1 / chi=0 in hnonlin.c */</span>
<a name="l00351"></a>00351         ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+0] = 0.0;
<a name="l00352"></a>00352         ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+1] = 0.0;
<a name="l00353"></a>00353         ta_M[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*j+2] = 0.0;
<a name="l00354"></a>00354       }
<a name="l00355"></a>00355     }
<a name="l00356"></a>00356     ierr = VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);CHKERRQ(ierr);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358     ierr = TaoAppSetInitialSolutionVec(taoapp,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00359"></a>00359   }
<a name="l00360"></a>00360   <span class="keywordflow">else</span> {
<a name="l00361"></a>00361     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Using spherical coordinates\n&quot;</span>);
<a name="l00362"></a>00362     ierr = VecCreate(PETSC_COMM_WORLD,&amp;Msphere);CHKERRQ(ierr);
<a name="l00363"></a>00363     ierr = VecSetSizes(Msphere,(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>-1)*gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);CHKERRQ(ierr);
<a name="l00364"></a>00364     ierr = VecSetFromOptions(Msphere);CHKERRQ(ierr);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366     ierr = VecDuplicate(Msphere,&amp;VHtotsphere);CHKERRQ(ierr);
<a name="l00367"></a>00367 <span class="preprocessor">#ifdef NO_VMS3</span>
<a name="l00368"></a>00368 <span class="preprocessor"></span>    ierr = VecDuplicate(Msphere,&amp;X2);CHKERRQ(ierr);
<a name="l00369"></a>00369 <span class="preprocessor">#endif</span>
<a name="l00370"></a>00370 <span class="preprocessor"></span>
<a name="l00371"></a>00371     ierr = TaoAppSetInitialSolutionVec(taoapp,Msphere);CHKERRQ(ierr);
<a name="l00372"></a>00372   }
<a name="l00373"></a>00373   ierr = TaoAppSetObjectiveAndGradientRoutine(taoapp,<a class="code" href="eminisolve_8c.html#afdcb9097ab9ba289da2189a2ce6b9385">TaoEvalEnergyGrad</a>,(<span class="keywordtype">void</span> *)gdata);CHKERRQ(ierr);
<a name="l00374"></a>00374   ierr = TaoSetConvergenceTest(tao,<a class="code" href="eminisolve_8c.html#a5eef315eb34f052b9e148bd70caaea92">ConvTest</a>,(<span class="keywordtype">void</span> *)gdata);CHKERRQ(ierr);
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 <span class="comment">/*</span>
<a name="l00377"></a>00377 <span class="comment">  PetscPrintf(PETSC_COMM_WORLD,&quot;Activating TAO Monitor\n&quot;);</span>
<a name="l00378"></a>00378 <span class="comment">  ierr = PetscOptionsSetValue(&quot;-tao_monitor&quot;,&quot;&quot;);CHKERRQ(ierr);</span>
<a name="l00379"></a>00379 <span class="comment">*/</span>
<a name="l00380"></a>00380 
<a name="l00381"></a>00381   <span class="comment">/* set defaults for line search options */</span>
<a name="l00382"></a>00382   ierr = PetscOptionsHasName(PETSC_NULL,<span class="stringliteral">&quot;-tao_ls_ftol&quot;</span>,&amp;flg);CHKERRQ(ierr);
<a name="l00383"></a>00383   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00384"></a>00384     ierr = PetscOptionsSetValue(<span class="stringliteral">&quot;-tao_ls_ftol&quot;</span>,<span class="stringliteral">&quot;1e-20&quot;</span>);CHKERRQ(ierr);
<a name="l00385"></a>00385   }
<a name="l00386"></a>00386   ierr = PetscOptionsHasName(PETSC_NULL,<span class="stringliteral">&quot;-tao_ls_rtol&quot;</span>,&amp;flg);CHKERRQ(ierr);
<a name="l00387"></a>00387   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00388"></a>00388     ierr = PetscOptionsSetValue(<span class="stringliteral">&quot;-tao_ls_rtol&quot;</span>,<span class="stringliteral">&quot;1e-1&quot;</span>);CHKERRQ(ierr);
<a name="l00389"></a>00389   }
<a name="l00390"></a>00390   ierr = PetscOptionsHasName(PETSC_NULL,<span class="stringliteral">&quot;-tao_ls_gtol&quot;</span>,&amp;flg);CHKERRQ(ierr);
<a name="l00391"></a>00391   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00392"></a>00392     ierr = PetscOptionsSetValue(<span class="stringliteral">&quot;-tao_ls_gtol&quot;</span>,<span class="stringliteral">&quot;0.99&quot;</span>);CHKERRQ(ierr);
<a name="l00393"></a>00393   }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-tao_max_its&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;tao_max_its,&amp;flg);CHKERRQ(ierr);
<a name="l00396"></a>00396   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00397"></a>00397     tao_max_its=500;
<a name="l00398"></a>00398     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00399"></a>00399       <span class="stringliteral">&quot;Option -tao_max_its not found, using default value: %i\n&quot;</span>,
<a name="l00400"></a>00400       tao_max_its
<a name="l00401"></a>00401     );
<a name="l00402"></a>00402   }
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   <span class="comment">/* Check for TAO command line options (listed here for consistency check with allopt.txt) */</span>
<a name="l00405"></a>00405   <span class="comment">/* evaluates</span>
<a name="l00406"></a>00406 <span class="comment">      PetscOptions &quot;-tao_fatol&quot;</span>
<a name="l00407"></a>00407 <span class="comment">      PetscOptions &quot;-tao_frtol&quot;</span>
<a name="l00408"></a>00408 <span class="comment">  */</span>
<a name="l00409"></a>00409 <span class="comment">/* defined in tao-1.9/src/petsctao/include/taopetsc.h - may not be supported in future releases</span>
<a name="l00410"></a>00410 <span class="comment">  ierr = TaoSetFromOptions(tao);CHKERRQ(ierr);</span>
<a name="l00411"></a>00411 <span class="comment">*/</span>
<a name="l00412"></a>00412   ierr = TaoSetOptions(taoapp,tao);CHKERRQ(ierr);
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   <span class="comment">/*</span>
<a name="l00415"></a>00415 <span class="comment">    disturb magnetization distribution with small random vector;</span>
<a name="l00416"></a>00416 <span class="comment">    larger distortions require many more interations in TaoSolve</span>
<a name="l00417"></a>00417 <span class="comment">    and do not help, because the solution is less accurate</span>
<a name="l00418"></a>00418 <span class="comment">    (relative tolerance!)</span>
<a name="l00419"></a>00419 <span class="comment">  */</span>
<a name="l00420"></a>00420   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-magdist&quot;</span>, &amp;magdist,&amp;flg);CHKERRQ(ierr);
<a name="l00421"></a>00421   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00422"></a>00422     magdist=0.0;
<a name="l00423"></a>00423     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00424"></a>00424       <span class="stringliteral">&quot;Option -magdist not found, using default value: %g\n&quot;</span>,
<a name="l00425"></a>00425       magdist
<a name="l00426"></a>00426     );
<a name="l00427"></a>00427   }
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   <span class="keywordflow">if</span> (magdist&lt;0.0) {
<a name="l00430"></a>00430     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;magdist = %g &lt; 0.0: Distorting M by tilting in direction MxMxH\n&quot;</span>,magdist);
<a name="l00431"></a>00431   }
<a name="l00432"></a>00432   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (magdist&gt;0.0) {
<a name="l00433"></a>00433     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;magdist = %g &gt; 0.0: Distorting M randomly\n&quot;</span>,magdist);
<a name="l00434"></a>00434   }
<a name="l00435"></a>00435   <span class="keywordflow">else</span> {
<a name="l00436"></a>00436     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;magdist==0.0: Not distorting M\n&quot;</span>);
<a name="l00437"></a>00437   }
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   ierr = PetscRandomCreate(PETSC_COMM_WORLD,&amp;rctx);CHKERRQ(ierr);
<a name="l00440"></a>00440   ierr = PetscRandomSetFromOptions(rctx);CHKERRQ(ierr);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="comment">/* To View TAO solver information use */</span>
<a name="l00443"></a>00443   ierr = TaoView(tao);CHKERRQ(ierr);
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-tol&quot;</span>,&amp;tol,&amp;flg);CHKERRQ(ierr);
<a name="l00446"></a>00446   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00447"></a>00447     tol=1e-7;
<a name="l00448"></a>00448     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00449"></a>00449       <span class="stringliteral">&quot;Option -tol not found, using default value: %g\n&quot;</span>,
<a name="l00450"></a>00450       tol
<a name="l00451"></a>00451     );
<a name="l00452"></a>00452   }
<a name="l00453"></a>00453   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;tol (equilibrium): %g\n&quot;</span>,tol);
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 <span class="preprocessor">#ifdef TESTTORQ</span>
<a name="l00456"></a>00456 <span class="preprocessor"></span>  ierr = VecDuplicate(gdata-&gt;M,&amp;dMdt);
<a name="l00457"></a>00457 <span class="preprocessor">#endif</span>
<a name="l00458"></a>00458 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00459"></a>00459 <span class="preprocessor"></span>  ierr = VecDuplicate(gdata-&gt;M,&amp;dMdt);
<a name="l00460"></a>00460 <span class="preprocessor">#endif</span>
<a name="l00461"></a>00461 <span class="preprocessor"></span>
<a name="l00462"></a>00462   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00463"></a>00463 }
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a><a class="code" href="eminisolve_8c.html#a17d21e725c11c8a2fade9a2d83d98047">00466</a> <span class="keywordtype">int</span> <a class="code" href="eminisolve_8c.html#a17d21e725c11c8a2fade9a2d83d98047">EminiSolve</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00467"></a>00467 {
<a name="l00468"></a>00468   <a class="code" href="griddata_8h.html#a4e81d68a7df0ff55ea65b46253e07552">MagparFunctionInfoBegin</a>;
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   <span class="keywordflow">if</span> (magdist&lt;0.0) {
<a name="l00471"></a>00471     <span class="comment">/* distort by tilting magnetization in direction of MxMxH */</span>
<a name="l00472"></a>00472     PetscReal *ta_M, *ta_Htot;
<a name="l00473"></a>00473     VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);
<a name="l00474"></a>00474     VecGetArray(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,&amp;ta_Htot);
<a name="l00475"></a>00475 
<a name="l00476"></a>00476     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>; i++) {
<a name="l00477"></a>00477       PetscReal  damp[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>], mxh[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00478"></a>00478 
<a name="l00479"></a>00479       <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,ta_Htot+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,mxh);
<a name="l00480"></a>00480       <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,mxh,damp);
<a name="l00481"></a>00481 
<a name="l00482"></a>00482       <span class="comment">/* TODO: can lead to Inf/NaNs if &quot;damping constant&quot; is too large */</span>
<a name="l00483"></a>00483       <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,magdist,damp,1,ta_M+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,1);
<a name="l00484"></a>00484     }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486     VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;ta_M);
<a name="l00487"></a>00487     VecRestoreArray(gdata-&gt;<a class="code" href="structGridData.html#a377c12744bdd4ce50a6d4394bd25e49a">VHtot</a>,&amp;ta_Htot);
<a name="l00488"></a>00488   }
<a name="l00489"></a>00489   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (magdist&gt;0.0) {
<a name="l00490"></a>00490     <span class="comment">/* randomly distort M */</span>
<a name="l00491"></a>00491     ierr = <a class="code" href="distortvec_8c.html#a8bf0a9f33e000474112d918b05b1b377">DistortVec</a>(rctx,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,magdist);CHKERRQ(ierr);
<a name="l00492"></a>00492 
<a name="l00493"></a>00493     <span class="comment">/* renormalize M */</span>
<a name="l00494"></a>00494     <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>!=53) {
<a name="l00495"></a>00495       PetscReal devNorm;
<a name="l00496"></a>00496       devNorm=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00497"></a>00497     }
<a name="l00498"></a>00498   }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500   PetscPrintf(MPI_COMM_WORLD,<span class="stringliteral">&quot;Starting energy minimization with TAO...\n&quot;</span>);
<a name="l00501"></a>00501   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;iter  equil  CPUtstep (s)   Etot (1)            (J/m^3)                Etotold  (1)             (J/m^3)               tol               torq\n&quot;</span>);
<a name="l00502"></a>00502   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;--------------------------------------------------------------------------------------------------------------------------------------------------------------\n&quot;</span>);
<a name="l00503"></a>00503 
<a name="l00504"></a>00504   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>!=53) {
<a name="l00505"></a>00505     ierr = <a class="code" href="cart2sphere_8c.html#a519926eb0e8844daa1219a94521b9882">Cart2Sphere</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,Msphere);CHKERRQ(ierr);
<a name="l00506"></a>00506 
<a name="l00507"></a>00507 <span class="preprocessor">#ifdef NO_VMS3</span>
<a name="l00508"></a>00508 <span class="preprocessor"></span><span class="comment">/*</span>
<a name="l00509"></a>00509 <span class="comment">    PetscReal *ta_X, *ta_VMs3;</span>
<a name="l00510"></a>00510 <span class="comment">    ierr = VecGetArray(Msphere,&amp;ta_X);CHKERRQ(ierr);</span>
<a name="l00511"></a>00511 <span class="comment">    ierr = VecGetArray(gdata-&gt;VMs3,&amp;ta_VMs3);CHKERRQ(ierr);</span>
<a name="l00512"></a>00512 <span class="comment">    for (int i=0; i&lt;gdata-&gt;ln_vert; i++) {</span>
<a name="l00513"></a>00513 <span class="comment">      ta_X[2*i+0] *= ta_VMs3[ND*i];</span>
<a name="l00514"></a>00514 <span class="comment">      ta_X[2*i+1] *= ta_VMs3[ND*i];</span>
<a name="l00515"></a>00515 <span class="comment">    }</span>
<a name="l00516"></a>00516 <span class="comment">    ierr = VecRestoreArray(Msphere,&amp;ta_X);CHKERRQ(ierr);</span>
<a name="l00517"></a>00517 <span class="comment">    ierr = VecRestoreArray(gdata-&gt;VMs3,&amp;ta_VMs3);CHKERRQ(ierr);</span>
<a name="l00518"></a>00518 <span class="comment">*/</span>
<a name="l00519"></a>00519 <span class="preprocessor">#endif</span>
<a name="l00520"></a>00520 <span class="preprocessor"></span>  }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   ierr = TaoSolveApplication(taoapp,tao);CHKERRQ(ierr);
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 <span class="preprocessor">#ifdef ADDONS</span>
<a name="l00525"></a>00525 <span class="preprocessor"></span>
<a name="l00526"></a>00526 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00527"></a>00527 <span class="preprocessor"></span>  <span class="comment">/* recalculate fields and energies */</span>
<a name="l00528"></a>00528   ierr = <a class="code" href="field_8h.html#ab9d30ce64708afeca163280386deb654">Htot</a>(gdata);CHKERRQ(ierr);
<a name="l00529"></a>00529   ierr = <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);CHKERRQ(ierr);
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=PetscAbsInt(gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>);
<a name="l00532"></a>00532   ierr = <a class="code" href="magpario_8h.html#ad970cf1663bac1ede525a5caf43750fd">WriteLog</a>(gdata);CHKERRQ(ierr);
<a name="l00533"></a>00533   ierr = <a class="code" href="magpario_8h.html#a7ff05d6bfdfc02445d6245fec57f686e">WriteSet</a>(gdata);CHKERRQ(ierr);
<a name="l00534"></a>00534 <span class="preprocessor">#endif</span>
<a name="l00535"></a>00535 <span class="preprocessor"></span>
<a name="l00536"></a>00536   PetscTruth flg;
<a name="l00537"></a>00537   <span class="keywordtype">int</span> NSMOOTHSTEPS;
<a name="l00538"></a>00538   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-emini_mag_smooth_steps&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;NSMOOTHSTEPS,&amp;flg);CHKERRQ(ierr);
<a name="l00539"></a>00539   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00540"></a>00540     NSMOOTHSTEPS=1;
<a name="l00541"></a>00541   }
<a name="l00542"></a>00542 
<a name="l00543"></a>00543   <span class="keywordflow">if</span> (NSMOOTHSTEPS&gt;0) {
<a name="l00544"></a>00544     PetscPrintf(MPI_COMM_WORLD,<span class="stringliteral">&quot;Smoothening magnetization distribution\n&quot;</span>);
<a name="l00545"></a>00545 
<a name="l00546"></a>00546     <span class="comment">/* smoothen magnetization distribution */</span>
<a name="l00547"></a>00547     Vec Vtmp;
<a name="l00548"></a>00548     ierr = VecDuplicate(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,&amp;Vtmp);CHKERRQ(ierr);
<a name="l00549"></a>00549 
<a name="l00550"></a>00550     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;NSMOOTHSTEPS;i++) {
<a name="l00551"></a>00551       <span class="comment">/* perform smoothening (double) step */</span>
<a name="l00552"></a>00552       ierr = FieldSmoothApply(gdata,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,Vtmp);
<a name="l00553"></a>00553       ierr = FieldSmoothApply(gdata,Vtmp,gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);
<a name="l00554"></a>00554 
<a name="l00555"></a>00555       <span class="comment">/* renormalize M (distorted due to smoothening) */</span>
<a name="l00556"></a>00556       PetscReal devNorm;
<a name="l00557"></a>00557       devNorm=<a class="code" href="renormvec_8c.html#abba3d002260d6e3e062ac69a80300aa4">RenormVec</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,1.0,0.0,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00558"></a>00558     }
<a name="l00559"></a>00559 
<a name="l00560"></a>00560     ierr = VecDestroy(Vtmp);CHKERRQ(ierr);
<a name="l00561"></a>00561   }
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>!=53) {
<a name="l00564"></a>00564     ierr = <a class="code" href="cart2sphere_8c.html#a519926eb0e8844daa1219a94521b9882">Cart2Sphere</a>(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,Msphere);CHKERRQ(ierr);
<a name="l00565"></a>00565   }
<a name="l00566"></a>00566 
<a name="l00567"></a>00567   <span class="keywordflow">if</span> (NSMOOTHSTEPS&gt;0) {
<a name="l00568"></a>00568     PetscPrintf(MPI_COMM_WORLD,<span class="stringliteral">&quot;Restarting energy minimization with TAO after smoothening...\n&quot;</span>);
<a name="l00569"></a>00569     ierr = TaoSolveApplication(taoapp,tao);CHKERRQ(ierr);
<a name="l00570"></a>00570   }
<a name="l00571"></a>00571 <span class="preprocessor">#endif</span>
<a name="l00572"></a>00572 <span class="preprocessor"></span>
<a name="l00573"></a>00573   <span class="keywordflow">if</span> (gdata-&gt;<a class="code" href="structGridData.html#ae420f7fb3d60720f21c5852955b94eae">mode</a>!=53) {
<a name="l00574"></a>00574     Vec sol;
<a name="l00575"></a>00575     ierr = TaoAppGetSolutionVec(taoapp,&amp;sol);CHKERRQ(ierr);
<a name="l00576"></a>00576     assert(sol==Msphere);
<a name="l00577"></a>00577   }
<a name="l00578"></a>00578   <span class="comment">/* store this info in log file!? */</span>
<a name="l00579"></a>00579   <span class="keywordtype">int</span> iter;
<a name="l00580"></a>00580   <span class="keywordtype">double</span> ff,gnorm,cnorm,xdiff;
<a name="l00581"></a>00581   TaoTerminateReason reason;
<a name="l00582"></a>00582   ierr = TaoGetSolutionStatus(tao,&amp;iter,&amp;ff,&amp;gnorm,&amp;cnorm,&amp;xdiff,&amp;reason);CHKERRQ(ierr);
<a name="l00583"></a>00583   <span class="keywordflow">if</span> (reason &lt;= 0 ){
<a name="l00584"></a>00584     PetscPrintf(MPI_COMM_WORLD,<span class="stringliteral">&quot;TAO solver did NOT converge - &quot;</span>);
<a name="l00585"></a>00585     <span class="comment">/* continue even if TAO fails</span>
<a name="l00586"></a>00586 <span class="comment">       SETERRQ(PETSC_ERR_LIB,&quot;TAO failed! Exiting!\n&quot;);</span>
<a name="l00587"></a>00587 <span class="comment">    */</span>
<a name="l00588"></a>00588     gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>=0;
<a name="l00589"></a>00589   }
<a name="l00590"></a>00590   <span class="keywordflow">else</span> {
<a name="l00591"></a>00591     PetscPrintf(MPI_COMM_WORLD,<span class="stringliteral">&quot;TAO solver converged - &quot;</span>);
<a name="l00592"></a>00592     gdata-&gt;<a class="code" href="structGridData.html#aa694f80ac28e20e0d11e13a3db947ed4">equil</a>++;
<a name="l00593"></a>00593   }
<a name="l00594"></a>00594   PetscPrintf(MPI_COMM_WORLD,
<a name="l00595"></a>00595     <span class="stringliteral">&quot;TerminationReason: %i\n&quot;</span>
<a name="l00596"></a>00596     <span class="stringliteral">&quot;it: %i, f: %4.2e, res: %4.2e, cnorm: %4.2e, step %4.2e\n&quot;</span>,
<a name="l00597"></a>00597     reason,
<a name="l00598"></a>00598     iter,ff,gnorm,cnorm,xdiff
<a name="l00599"></a>00599   );
<a name="l00600"></a>00600 
<a name="l00601"></a>00601   ierr = TaoView(tao);CHKERRQ(ierr);
<a name="l00602"></a>00602 
<a name="l00603"></a>00603   <span class="comment">/* otherwise Htot=0 */</span>
<a name="l00604"></a>00604   ierr = <a class="code" href="field_8h.html#ab9d30ce64708afeca163280386deb654">Htot</a>(gdata);CHKERRQ(ierr);
<a name="l00605"></a>00605   ierr = <a class="code" href="field_8h.html#a09d3a5bbcb3e65c1e4c7e22818377b13">Htot_Energy</a>(gdata);CHKERRQ(ierr);
<a name="l00606"></a>00606 
<a name="l00607"></a>00607   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00608"></a>00608 }
<a name="l00609"></a>00609 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

